diff -ruNp linux-2.6.23.16/mm/mlock.c linux-2.6.23.16-cher1/mm/mlock.c
--- linux-2.6.23.16/mm/mlock.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/mlock.c	2008-02-12 11:21:39.000000000 +0300
@@ -138,6 +138,11 @@ asmlinkage long sys_mlock(unsigned long 
 	unsigned long lock_limit;
 	int error = -ENOMEM;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!can_do_mlock())
 		return -EPERM;
 
@@ -162,6 +167,11 @@ asmlinkage long sys_munlock(unsigned lon
 {
 	int ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	down_write(&current->mm->mmap_sem);
 	len = PAGE_ALIGN(len + (start & ~PAGE_MASK));
 	start &= PAGE_MASK;
@@ -200,6 +210,11 @@ asmlinkage long sys_mlockall(int flags)
 	unsigned long lock_limit;
 	int ret = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!flags || (flags & ~(MCL_CURRENT | MCL_FUTURE)))
 		goto out;
 
@@ -225,6 +240,11 @@ asmlinkage long sys_munlockall(void)
 {
 	int ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	down_write(&current->mm->mmap_sem);
 	ret = do_mlockall(0);
 	up_write(&current->mm->mmap_sem);
@@ -266,3 +286,9 @@ void user_shm_unlock(size_t size, struct
 	spin_unlock(&shmlock_user_lock);
 	free_uid(user);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/mm/mmap.c linux-2.6.23.16-cher1/mm/mmap.c
--- linux-2.6.23.16/mm/mmap.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/mmap.c	2008-02-12 11:21:39.000000000 +0300
@@ -252,8 +252,13 @@ asmlinkage unsigned long sys_brk(unsigne
 	 * not page aligned -Ram Gupta
 	 */
 	rlim = current->signal->rlim[RLIMIT_DATA].rlim_cur;
-	if (rlim < RLIM_INFINITY && brk - mm->start_data > rlim)
+	if (rlim < RLIM_INFINITY && brk - mm->start_data > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                        send_sig(SIGKILL, current, 0);
+                }
 		goto out;
+        }
 
 	newbrk = PAGE_ALIGN(brk);
 	oldbrk = PAGE_ALIGN(mm->brk);
@@ -1518,8 +1523,13 @@ static int acct_stack_growth(struct vm_a
 		return -ENOMEM;
 
 	/* Stack limit test */
-	if (size > rlim[RLIMIT_STACK].rlim_cur)
+	if (size > rlim[RLIMIT_STACK].rlim_cur) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                        send_sig(SIGKILL, current, 0);
+                }
 		return -ENOMEM;
+        }
 
 	/* mlock limit tests */
 	if (vma->vm_flags & VM_LOCKED) {
@@ -2156,8 +2166,13 @@ int may_expand_vm(struct mm_struct *mm, 
 
 	lim = current->signal->rlim[RLIMIT_AS].rlim_cur >> PAGE_SHIFT;
 
-	if (cur + npages > lim)
+	if (cur + npages > lim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                        send_sig(SIGKILL, current, 0);
+                }
 		return 0;
+        }
 	return 1;
 }
 
@@ -2232,3 +2247,9 @@ int install_special_mapping(struct mm_st
 
 	return 0;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/mm/mprotect.c linux-2.6.23.16-cher1/mm/mprotect.c
--- linux-2.6.23.16/mm/mprotect.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/mprotect.c	2008-02-12 11:21:39.000000000 +0300
@@ -221,6 +221,10 @@ sys_mprotect(unsigned long start, size_t
 	struct vm_area_struct *vma, *prev;
 	int error = -EINVAL;
 	const int grows = prot & (PROT_GROWSDOWN|PROT_GROWSUP);
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	prot &= ~(PROT_GROWSDOWN|PROT_GROWSUP);
 	if (grows == (PROT_GROWSDOWN|PROT_GROWSUP)) /* can't be both */
 		return -EINVAL;
diff -ruNp linux-2.6.23.16/mm/mremap.c linux-2.6.23.16-cher1/mm/mremap.c
--- linux-2.6.23.16/mm/mremap.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/mremap.c	2008-02-12 11:21:39.000000000 +0300
@@ -423,3 +423,9 @@ asmlinkage unsigned long sys_mremap(unsi
 	up_write(&current->mm->mmap_sem);
 	return ret;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/mm/swapfile.c linux-2.6.23.16-cher1/mm/swapfile.c
--- linux-2.6.23.16/mm/swapfile.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/mm/swapfile.c	2008-02-12 11:21:39.000000000 +0300
@@ -1183,6 +1183,11 @@ asmlinkage long sys_swapoff(const char _
 	int i, type, prev;
 	int err;
 	
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
@@ -1433,6 +1438,11 @@ asmlinkage long sys_swapon(const char __
 	struct inode *inode = NULL;
 	int did_down = 0;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	spin_lock(&swap_lock);
diff -ruNp linux-2.6.23.16/net/compat.c linux-2.6.23.16-cher1/net/compat.c
--- linux-2.6.23.16/net/compat.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/net/compat.c	2008-02-12 11:21:39.000000000 +0300
@@ -648,6 +648,11 @@ asmlinkage long compat_sys_socketcall(in
 	u32 a[6];
 	u32 a0, a1;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (call < SYS_SOCKET || call > SYS_RECVMSG)
 		return -EINVAL;
 	if (copy_from_user(a, args, nas[call]))
diff -ruNp linux-2.6.23.16/net/socket.c linux-2.6.23.16-cher1/net/socket.c
--- linux-2.6.23.16/net/socket.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/net/socket.c	2008-02-12 11:21:39.000000000 +0300
@@ -1199,6 +1199,11 @@ asmlinkage long sys_socket(int family, i
 	int retval;
 	struct socket *sock;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	retval = sock_create(family, type, protocol, &sock);
 	if (retval < 0)
 		goto out;
@@ -1227,6 +1232,11 @@ asmlinkage long sys_socketpair(int famil
 	int fd1, fd2, err;
 	struct file *newfile1, *newfile2;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	/*
 	 * Obtain the first socket and check if the underlying protocol
 	 * supports the socketpair call.
@@ -1325,6 +1335,11 @@ asmlinkage long sys_bind(int fd, struct 
 	char address[MAX_SOCK_ADDR];
 	int err, fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock) {
 		err = move_addr_to_kernel(umyaddr, addrlen, address);
@@ -1355,6 +1370,11 @@ asmlinkage long sys_listen(int fd, int b
 	struct socket *sock;
 	int err, fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock) {
 		if ((unsigned)backlog > sysctl_somaxconn)
@@ -1389,6 +1409,11 @@ asmlinkage long sys_accept(int fd, struc
 	int err, len, newfd, fput_needed;
 	char address[MAX_SOCK_ADDR];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1478,6 +1503,11 @@ asmlinkage long sys_connect(int fd, stru
 	char address[MAX_SOCK_ADDR];
 	int err, fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1510,6 +1540,11 @@ asmlinkage long sys_getsockname(int fd, 
 	char address[MAX_SOCK_ADDR];
 	int len, err, fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (!sock)
 		goto out;
@@ -1541,6 +1576,11 @@ asmlinkage long sys_getpeername(int fd, 
 	char address[MAX_SOCK_ADDR];
 	int len, err, fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock != NULL) {
 		err = security_socket_getpeername(sock);
@@ -1578,6 +1618,11 @@ asmlinkage long sys_sendto(int fd, void 
 	int fput_needed;
 	struct file *sock_file;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock_file = fget_light(fd, &fput_needed);
 	err = -EBADF;
 	if (!sock_file)
@@ -1639,6 +1684,11 @@ asmlinkage long sys_recvfrom(int fd, voi
 	struct file *sock_file;
 	int fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock_file = fget_light(fd, &fput_needed);
 	err = -EBADF;
 	if (!sock_file)
@@ -1692,6 +1742,11 @@ asmlinkage long sys_setsockopt(int fd, i
 	int err, fput_needed;
 	struct socket *sock;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (optlen < 0)
 		return -EINVAL;
 
@@ -1726,6 +1781,11 @@ asmlinkage long sys_getsockopt(int fd, i
 	int err, fput_needed;
 	struct socket *sock;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock != NULL) {
 		err = security_socket_getsockopt(sock, level, optname);
@@ -1755,6 +1815,11 @@ asmlinkage long sys_shutdown(int fd, int
 	int err, fput_needed;
 	struct socket *sock;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	sock = sockfd_lookup_light(fd, &err, &fput_needed);
 	if (sock != NULL) {
 		err = security_socket_shutdown(sock, how);
@@ -1791,6 +1856,11 @@ asmlinkage long sys_sendmsg(int fd, stru
 	int err, ctl_len, iov_size, total_len;
 	int fput_needed;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	err = -EFAULT;
 	if (MSG_CMSG_COMPAT & flags) {
 		if (get_compat_msghdr(&msg_sys, msg_compat))
@@ -1898,6 +1968,11 @@ asmlinkage long sys_recvmsg(int fd, stru
 	struct sockaddr __user *uaddr;
 	int __user *uaddr_len;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (MSG_CMSG_COMPAT & flags) {
 		if (get_compat_msghdr(&msg_sys, msg_compat))
 			return -EFAULT;
@@ -2002,6 +2077,11 @@ asmlinkage long sys_socketcall(int call,
 	unsigned long a0, a1;
 	int err;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (call < 1 || call > SYS_RECVMSG)
 		return -EINVAL;
 
@@ -2340,3 +2420,9 @@ EXPORT_SYMBOL(kernel_getsockopt);
 EXPORT_SYMBOL(kernel_setsockopt);
 EXPORT_SYMBOL(kernel_sendpage);
 EXPORT_SYMBOL(kernel_sock_ioctl);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/security/keys/keyctl.c linux-2.6.23.16-cher1/security/keys/keyctl.c
--- linux-2.6.23.16/security/keys/keyctl.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/security/keys/keyctl.c	2008-02-12 11:21:39.000000000 +0300
@@ -63,6 +63,11 @@ asmlinkage long sys_add_key(const char _
 	void *payload;
 	long ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	ret = -EINVAL;
 	if (plen > 32767)
 		goto error;
@@ -143,6 +148,11 @@ asmlinkage long sys_request_key(const ch
 	char type[32], *description, *callout_info;
 	long ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	/* pull the type into kernel space */
 	ret = key_get_type_from_user(type, _type, sizeof(type));
 	if (ret < 0)
@@ -1062,6 +1072,11 @@ error:
 asmlinkage long sys_keyctl(int option, unsigned long arg2, unsigned long arg3,
 			   unsigned long arg4, unsigned long arg5)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	switch (option) {
 	case KEYCTL_GET_KEYRING_ID:
 		return keyctl_get_keyring_ID((key_serial_t) arg2,
@@ -1140,3 +1155,9 @@ asmlinkage long sys_keyctl(int option, u
 	}
 
 } /* end sys_keyctl() */
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
